﻿using Obvs.Configuration;
using System;
using System.Collections.Generic;
using System.Text;

namespace Obvs.Logging.NetCore
{
    public static class NetCoreLoggerExtensions
    {
        public static ICanCreate<TMessage, TCommand, TEvent, TRequest, TResponse> 
            UsingNetCoreLogging<TMessage, TCommand, TEvent, TRequest, TResponse>(
                this ICanSpecifyLogging<TMessage, TCommand, TEvent, TRequest, TResponse> canSpecifyLogging,
                Microsoft.Extensions.Logging.ILoggerFactory factory )
            where TMessage : class
            where TCommand : class, TMessage
            where TEvent : class, TMessage
            where TRequest : class, TMessage
            where TResponse : class, TMessage
        {
            if (factory == null)
                return (ICanCreate<TMessage, TCommand, TEvent, TRequest, TResponse>)canSpecifyLogging;

            return canSpecifyLogging.UsingLogging(
                new NetCoreLoggerFactory(factory),
                _ => true,
                _ => Obvs.Logging.LogLevel.Debug,
                _ => Obvs.Logging.LogLevel.Debug);
        }
    }
}
